/*
 *  Multiplucker.h
 *  everylayer2
 *
 *  Created by Andrew on 12/8/10.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#import "stk/Stk.h"
#import "stk/Plucked.h"
#import <vector>

using namespace stk;

// class for polyphony on top of Plucked instrument from stk

class Multipluck : public Instrmnt {
	
public:
	
	Multipluck(StkFloat lowestFrequency);
	~Multipluck();
	
	//! Start a note with the given frequency and amplitude.
	void noteOn( StkFloat frequency, StkFloat amplitude );
	void noteOff( StkFloat amplitude ) {} // do nothing
	
	//! Compute and return one output sample.
	StkFloat tick(unsigned int channel=0);

private:
	
	std::vector<Plucked *> *m_synths;
	unsigned int m_currentSynth;
	unsigned int m_numSynths;
	
};